Description

This code works:

array = %w( b c )  # => ["b", "c"]

array.unshift "a"

array              # => ["a", "b", "c"]

 I would like for .prepend to also work on class Array.

Rationale:

I found myself to sometimes .prepend to a String object

in Ruby, which works very well.

Sometimes I do not want to care whether I have a String

or an Array, I just want to prepend stuff (add to the

beginning).

I can do so via .unshift, fair enough, and I also can

use [] such as:

array[0,0] = 'a'

 Which works on both class String and Array.

Since class Hash is sorted (kept in order) these days,

perhaps they can also use a .prepend variant, which

either works for prepending both a key-value pair,

or optionally, to make the value default to nil and

just provide a key (if the user does not need to

specify a specific value) such as:

hash.prepend :cat

hash.prepend cat: :Tom

 But primarily, I only ask for class Array since I

have had use cases for class Array; I did not yet

have a similar use case for class Hash.

Feel free to close this if it is considered unwanted

for any reason!

Associated revisions

Revision f57d515d69b7a35477b9ba5d08fe117df1f1e275 - 04/01/2017 07:38 AM - nobu (Nobuyoshi Nakada)

array.c: Array#append and Array#prepend

array.c (Init_Array): Add alias "append" to Array#push, and

"prepend" to Array#unshift.  [Feature #12746] [Fix GH-1574]

Author:    pascbjumper2 stowers.joshua@live.com

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@58227 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision b6b4af0e1ed7e454f9618b423e6d1bed0ed052e8 - 04/06/2017 12:14 AM - znz (Kazuhiro NISHIYAMA)
[Feature #12746] [ci skip]
History

#1 - 09/14/2016 09:40 PM - nrodriguez (Nicolas Rodriguez)

Also .prepend sounds more natural than .unshift (specialy on Array). But it also implies .append which should be aliased to .push.

Example :

[1, 2, 3,].append(4).append(5)

#2 - 11/25/2016 07:46 AM - matz (Yukihiro Matsumoto)

Accepted.

Matz.

#3 - 11/25/2016 07:51 AM - matsuda (Akira Matsuda)

FIY both append and prepend are in ActiveSupport: 

https://github.com/rails/rails/blob/master/activesupport/lib/active_support/core_ext/array/prepend_and_append.rb

#4 - 03/31/2017 06:48 AM - JustJosh (Joshua Stowers)

Thanks, Matz! I've been wanting this for a while.

I've just made a PR to the Github repo with the changes: https://github.com/ruby/ruby/pull/1574

#5 - 04/01/2017 07:38 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r58227.
